#include <common.h>
#include <command.h>
#include <asm/mipsregs.h>
#include <asm/addrspace.h>
#include <config.h>
#include <version.h>
#include "ar7100_soc.h"
extern const char version_string[];

void
ar7100_usb_initial_config(void)
{
    ar7100_reg_wr_nf(AR7100_USB_PLL_CONFIG, 0x00001030);
}

#define FAILED          1
#define PASSED          0
#define CYG_ADDRWORD unsigned long 
#define cyg_uint32 unsigned int
#define cyg_uint8  unsigned char
#define cyg_uint16 unsigned short
typedef void thand_f(void);

static thand_f *timeHandler;
static ulong timeStart;
static ulong timeDelta;
extern int tstc (void);
extern void NetSetTimeout(ulong,thand_f *);

int
ar7100_mem_config()
{
    uint32_t  ddr_config, ddr_config2;
    int i;
#if 0
    ar7100_ddr_width_t width;
#endif

    ar7100_ddr_initial_config(CFG_DDR_REFRESH_VAL);
#if 0
    ar7100_ddr_tap_config();
#else
    ar7100_reg_wr (AR7100_DDR_TAP_CONTROL0, 0x0);
    ar7100_reg_wr (AR7100_DDR_TAP_CONTROL1, 0x0);
    ar7100_reg_wr (AR7100_DDR_TAP_CONTROL2, 0x0);
    ar7100_reg_wr (AR7100_DDR_TAP_CONTROL3, 0x0);
#endif

#if 0
    ddr_config   = ar7100_reg_rd(AR7100_DDR_CONFIG);
    ddr_config2  = ar7100_reg_rd(AR7100_DDR_CONFIG2);
    width        = ar7100_ddr_get_width();

    if (width != AR7100_DDR_32B)
        ddr_config |= AR7100_DDR_CONFIG_16BIT;
    if (width == AR7100_DDR_16B_HIGH)
        ddr_config2 &= ~AR7100_DDR_CONFIG2_HALF_WIDTH_L;

    ddr_config2 &= ~((0x1f << AR7100_DDR_CONFIG2_TRTW_SHIFT) |
                     (0x1f << AR7100_DDR_CONFIG2_TWTR_SHIFT) |
                      0xf);

    ddr_config2 |= ((CFG_DDR_TRTW_VAL << AR7100_DDR_CONFIG2_TRTW_SHIFT) |
                    (CFG_DDR_TWTR_VAL << AR7100_DDR_CONFIG2_TWTR_SHIFT) |
                    AR7100_DDR_CONFIG2_BL2);
    /*
     * XXX These bits are reserved...
     */
    ddr_config2 |= (1 << 26)|(1 << 27)|(1 << 30);

    printf("programming config1 %#x, config2 %#x\n", ddr_config, ddr_config2);

    ar7100_reg_wr(AR7100_DDR_CONFIG, ddr_config);
    ar7100_reg_wr(AR7100_DDR_CONFIG2, ddr_config2);
#endif

    /* XXX - these don't really belong here!
    *(volatile unsigned int *)0xb8050004 = 0x00001032;
    udelay(100);
*/
#ifndef AR9100
    *(volatile unsigned int *)0xb8050018 = 0x1313;
    udelay(10);
#endif
#if 0
    *(volatile unsigned int *)0xb805001c = 0x00000909;
    udelay(100);

    *(volatile unsigned int *)0xb8050014 = 0x14000044;
    udelay(100);
#endif

    i = *(volatile int *)0xb8050004;
    i = i & (~(1 << 25));
    *(volatile int *)0xb8050004 = i;
    while ((*(volatile int *)0xb8050004) & (1 << 17));

    i = *(volatile int *)0xb8050004;
    i = i & (~(1 << 16));
    *(volatile int *)0xb8050004 = i;
    while ((*(volatile int *)0xb8050004) & (1 << 17));

    i = *(volatile int *)0xb8050004;
    i = i | (0x3f << 19);
    *(volatile int *)0xb8050004 = i;
    udelay(100);

    *(volatile int *)0xb8050014 = 0x13000a44;
/*
    *(volatile int *)0xb8050014 = 0x13000044;
    *(volatile int *)0xb8050014 = 0x13111321;
    *(volatile int *)0xb8050014 = 0x00111321;
    *(volatile int *)0xb8050014 = 0x00001344;
    *(volatile int *)0xb8050014 = 0x14000044;
    *(volatile int *)0xb8050014 = 0x14000f44;
    *(volatile int *)0xb8050014 = 0x00001044;
    *(volatile int *)0xb8050014 = 0x14001044;
    *(volatile int *)0xb8050014 = 0x14001f44;
    *(volatile int *)0xb8050014 = 0x1f001044;
    *(volatile int *)0xb8050014 = 0x1f001f44;
*/

    *(volatile int *)0xb805001c = 0x00000909;
    udelay(100);

    i = *(volatile int *)0xb8050004;
    i = i & (~(0x3b << 19));
    *(volatile int *)0xb8050004 = i;
    udelay(100);

    i = *(volatile int *)0xb8050004;
    i = i | (0x3 << 20);
    *(volatile int *)0xb8050004 = i;
    udelay(100);

    i = *(volatile int *)0xb8050004;
    i = i & (~(0x3 << 20));
    *(volatile int *)0xb8050004 = i;
    udelay(100);

    /* Temp addition - check with Ravi */
    *(volatile unsigned int *)0xb8080008 = 0x00000040;
    udelay(100);

    ar7100_usb_initial_config();

    i = ar7100_ddr_find_size();

    /*
      Set the First LED to AMBER -- turn off POWER LED and turn on DIAG LED.
    */
    ar7100_led_off(AR7100_POWER_LED);
    ar7100_led_on(AR7100_DIAG_LED);
    
    printf ("\n\n%s\n\n", version_string);
    printf("AP81 (ar7100) U-boot\n");
    printf("sri\n");

    return i;
}

long int initdram(int board_type)
{
    return (ar7100_mem_config());
}

int checkboard (void)
{
	return 0;
}

void DurTimeSet(ulong iv)
{
		timeStart = get_timer(0);
		timeDelta = iv;
	//	printf("\nprogram run time %lu\n",timeStart);
}
 int
onesTest(CYG_ADDRWORD *testAddr)
{
	CYG_ADDRWORD theOne,dataRead;
	int	fail, loopCount = 0; // To keep track of when to print CR
	printf("\n");
	// Loop for all bits in an address
	for (theOne = 1, fail = 0; theOne && !fail; theOne <<= 1) {
		testAddr[0] = theOne;     // Write test data
		testAddr[1] = ~0L;        // Drive d0-dn hi
		dataRead = *testAddr;     // Read back data
		printf("%08x%s", dataRead, (loopCount++ % 8) ? "" : "\n");
		if (dataRead != theOne)  // Verify data
			 return FAILED;       // Signal failure
	}
	return PASSED;
}
// Do 32-bit word address test

int
Addr32 (cyg_uint32 *start, cyg_uint32 *end, CYG_ADDRWORD  *badAddr)
{
	cyg_uint32  *currentAddr; /* Current address being tested */
	cyg_uint32  data;
	for(currentAddr = start; currentAddr <= end; currentAddr++)
		*currentAddr = (cyg_uint32)(CYG_ADDRWORD)currentAddr;
	for (currentAddr = start; currentAddr <= end; currentAddr++) {
		data = *currentAddr;
		if (data != (cyg_uint32)(CYG_ADDRWORD)currentAddr) {
			printf ("\n\nBad Read, Address = %p, Data Read = 0x%08x\n\n",currentAddr, data);
			*badAddr = (CYG_ADDRWORD)currentAddr;
			return FAILED;
		}
	}
	return PASSED;
}
// Do inverse long word address test
int
Bar32 (cyg_uint32 *start, cyg_uint32 *end, CYG_ADDRWORD *badAddr)
{
	cyg_uint32 *currentAddr, data;
	for(currentAddr = start; currentAddr <= end; currentAddr++)
		*currentAddr = ~(cyg_uint32)(CYG_ADDRWORD)currentAddr;
	for (currentAddr = start; currentAddr <= end; currentAddr++) {
		data = *currentAddr;
		if (data != (~(cyg_uint32)(CYG_ADDRWORD)currentAddr) & 0xffffffff) {
			printf ("\n\nBad Read, Address = %p, Data Read = 0x%08x\n\n",currentAddr, data);
			*badAddr = (CYG_ADDRWORD)currentAddr;
			return FAILED;
		}
	}
	return PASSED;
}
// Do byte address test
int
Addr8 (char *start, char  *end, CYG_ADDRWORD *badAddr)
{
	char *currentAddr; // Current address being tested
	for (currentAddr = start; currentAddr <= end; currentAddr++)
		*currentAddr = (char)(CYG_ADDRWORD)currentAddr;
	for (currentAddr = start; currentAddr <= end; currentAddr++)
		if (*currentAddr != (char)(CYG_ADDRWORD)currentAddr) {
			*badAddr = (CYG_ADDRWORD)currentAddr;
			return FAILED;
		}
		return PASSED;
}
// Do inverse byte address test
int
Bar8 (char *start, char *end, CYG_ADDRWORD *badAddr)
{
	char *currentAddr; 
	for(currentAddr = start; currentAddr <= end; currentAddr++)
		*currentAddr = ~(char)(CYG_ADDRWORD)currentAddr;

	for(currentAddr = start; currentAddr <= end; currentAddr++)
		if (*currentAddr != (~(char)(CYG_ADDRWORD)currentAddr) & 0xff) {	
			*badAddr = (CYG_ADDRWORD)currentAddr;
			return FAILED;
		}
	return PASSED;
}
// This routine is called if one of the memory tests fails.  It dumps
// the 8 32-bit words before and the 8 after the failure address
void
dumpMem (CYG_ADDRWORD badAddr)
{
	 cyg_uint32 *addr;
	 short *saddr;
	 int i;
	 // Print out first line of mem dump
	printf("\n%p: %08x %08x %08x %08x",
		(char *)badAddr - 32,
		*(cyg_uint32 *)(badAddr - 32),
		*(cyg_uint32 *)(badAddr - 28),
		*(cyg_uint32 *)(badAddr - 24),
		*(cyg_uint32 *)(badAddr - 20));
	printf("\n%p: %08x %08x %08x %08x",
		(char *)badAddr - 16,
		*(cyg_uint32 *)(badAddr - 16),
		*(cyg_uint32 *)(badAddr - 12),
		*(cyg_uint32 *)(badAddr - 8),
		*(cyg_uint32 *)(badAddr - 4));
	// Print out contents of fault addr
	printf("\n%p: %08x",
		(char *)badAddr, *(cyg_uint32 *)badAddr);
	printf("\n%p: %08x %08x %08x %08x",	
		(char *)badAddr + 4,
		*(cyg_uint32 *)(badAddr + 4),
		*(cyg_uint32 *)(badAddr + 8),
		*(cyg_uint32 *)(badAddr + 12),
		*(cyg_uint32 *)(badAddr + 16));

	printf("\n%p: %08x %08x %08x %08x",
		(char *)badAddr + 20,
		*(cyg_uint32 *)(badAddr + 20),
		*(cyg_uint32 *)(badAddr + 24),
		*(cyg_uint32 *)(badAddr + 28),
		*(cyg_uint32 *)(badAddr + 32));	

	/* DEBUG */
	printf ("\n\nReading back data in 32bit chunks:\n");
	for (addr = (cyg_uint32 *)(badAddr - 16), i = 0; i <= 8; i++, addr++)
		printf ("Address = %p, Data = 0x%08x\n", addr, *addr);
	printf ("\n");
	printf ("Reading back data in 16bit chunks:\n");
	for (saddr = (cyg_uint16 *)(badAddr - 16), i = 0; i <= 16; i++, saddr++)
	printf ("Address = %p, Data = 0x%08x\n", saddr, *saddr);
	printf ("\n");
}

 void memtst_print_banner(void)
{
	printf("\nUBOOT-1.1.4 Memory testing TOOL copyright DNI . \n");
}

 void memtst_usage(void)
{
	printf("Usage:\nmemtest [beginaddr] [endaddr] [durtime(sec)]\n");
	printf("\nvallid memory test address range from 0x80000000 to 0x81f00000\n");
	printf("For instance : memtest 0x80060000 0x80080000 20\n");
}

/* 02/02/01 jwf */
/* Do alternating inverse long word address test */
int
ABar32(cyg_uint32 *start,		/* Starting address of test */
	   cyg_uint32 *end,		/* Ending address */
	   CYG_ADDRWORD *badAddr)		/* Failure address */

{
	register cyg_uint32 *currentAddr;	/* Current address being tested */
	int fail = 0;		/* Test hasn't failed yet */
	cyg_uint32 data;
	/* In this test, the contents of each longword address toggles 
	   between the Address and the Address BAR */
	for(currentAddr = start; currentAddr <= end; currentAddr++) {
		if ((CYG_ADDRWORD)currentAddr & 4) /* Address ending in 0x4 or 0xc */
			*currentAddr = ~(cyg_uint32)(CYG_ADDRWORD)currentAddr;
		else /* Address ending in 0x0 or 0x8 */ 
			*currentAddr = (cyg_uint32)(CYG_ADDRWORD)currentAddr;
	}
	for (currentAddr = start; currentAddr <= end && !fail; currentAddr++) {
		data = *currentAddr;
		switch ((CYG_ADDRWORD)currentAddr & 0xf) {
			case 0x0:
			case 0x8:
				if (data != (cyg_uint32)(CYG_ADDRWORD)currentAddr) {
					fail = 1;
					printf ("\nFailed at Address %p, Expected 0x%08X, Read 0x%08X\n",
							currentAddr, (cyg_uint32)(CYG_ADDRWORD)currentAddr, data);
				}
				break;
			case 0x4:
			case 0xc:
				if (data != ~(cyg_uint32)(CYG_ADDRWORD)currentAddr) {
					fail = 1;
					printf ("\nFailed at Address %p, Expected 0x%08X, Read 0x%08X\n",currentAddr, ~(cyg_uint32)(CYG_ADDRWORD)currentAddr, data);
				}
				break;
			default:
				fail = 1;
				printf ("\nFailed at Address %p, Unaligned address\n", currentAddr);
				break;
		}
	}
	if (fail) {

		*badAddr = (CYG_ADDRWORD)(--currentAddr);
		return FAILED;
	} else
		return PASSED;
}
int
LoopMemTest (CYG_ADDRWORD startAddr, CYG_ADDRWORD endAddr,ulong myTime)
{
	CYG_ADDRWORD badAddr;  /* Addr test failed at */
	volatile int junk;
	int flag = 1;
	int myflag = 1;
	unsigned long mycount = 0;
	while (1) {
	
	  again:
		switch (myflag){
			case 1:
				if(!(mycount%4))	
				{
					printf("test continue,please wait...\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b");
					myflag = 0;
				}
				break;
			case 0:
		
				if(!(mycount%4))
				{	
					printf("                            \b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b");
					myflag = 1;
				}
				break;
			default:
				break;
		}
		
		if (Addr32((cyg_uint32 *)startAddr, (cyg_uint32 *)endAddr, &badAddr) == FAILED)
			break;
		if (Bar32((cyg_uint32 *)startAddr, (cyg_uint32 *)endAddr, &badAddr) == FAILED)
			break;
		if (Addr8((cyg_uint8 *)startAddr, (cyg_uint8 *)endAddr, &badAddr) == FAILED)
			break;
		if (Bar8((cyg_uint8 *)startAddr, (cyg_uint8 *)endAddr, &badAddr) == FAILED)
			break;
		if (ABar32((cyg_uint32 *)startAddr, (cyg_uint32 *)endAddr, &badAddr) == FAILED)
			break;
		if(myTime > 21) //max time digits
		{
			if(get_timer(0) > 4094967295){
				reset_timer();
				myTime -= 21;
			}
			mycount ++;
			goto again;
		}else
		{
			if(flag){
				reset_timer();
				DurTimeSet(myTime*CFG_HZ);
				flag = 0;
			}
		}
		
		
		if((get_timer(0) - timeStart) > timeDelta){
			printf("\npressure test memory come over,everyting is OK!\n");
			return PASSED;
		}
		mycount ++;
	}
	printf("failed at Address %p\n", badAddr);
	printf("Performing Continuous Write/Read/!Write/Read...\n\n");
	while (1) {
		*(volatile int *)badAddr = badAddr;
		junk = *(volatile int *)badAddr;
		*(volatile int *)badAddr = ~badAddr;
	}
	return 1;	// not reached
}

void GpioSet(unsigned long regoffs,unsigned long mask,unsigned long value)
{
	unsigned long gppData;
	gppData = *((volatile unsigned long*)regoffs);
	if(value)
		gppData |= mask;
	else
		gppData &= ~mask;
	*((volatile unsigned long *)regoffs) = gppData;
}
